{-|
Module      : PUBMED.Types
Description : PubMed API integration
Copyright   : (c) CNRS, 20198
License     : AGPL + CECILL v3
Maintainer  : team@gargantext.org
Stability   : experimental
Portability : POSIX
-}


module PUBMED.Types where

import Control.Monad.Reader (ReaderT)
import Data.Text (Text)


type APIKey = Text
type Offset = Integer
type Query = Text
type PerPage = Integer
type WebEnv = Text

data Config = Config {
    apiKey  :: Maybe APIKey
  , query   :: Query
  , perPage :: Maybe PerPage
  , mWebEnv :: Maybe WebEnv
  }

type Env = ReaderT Config IO


-- | This is the default `retmax` value in ESearch.
defaultPerPage :: PerPage
defaultPerPage = 20
